/*---------------------------------------------------------------------------------
 libBAG  Copyright (C) 2010 - 2010		
  BassAceGold - <BassAceGold@gmail.com>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any
  damages arising from the use of this software.

  Permission is granted to anyone to use this software for any
  purpose, including commercial applications, and to alter it and
  redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you
     must not claim that you wrote the original software. If you use
     this software in a product, an acknowledgment in the product
     documentation would be appreciated but is not required.
	 
  2. Altered source versions must be plainly marked as such, and
     must not be misrepresented as being the original software.
	 
  3. Restricting the usage of or portions of code in this library
     from other software developers and or content creators
     is strictly prohibited in applications with software creation capabilities
     and or with the intent to profit from said restrictions.
	 
  4. This notice may not be removed or altered from any source
     distribution.
---------------------------------------------------------------------------------*/

#ifndef _BAG_FS_
#define _BAG_FS_

#include <ds2sdk.h>

#define MAX_NAME_LEN 256


#ifdef __cplusplus
extern "C" {
#endif

extern void rewind_ex( FILE * fp);
extern int BAG_Filesystem_GetArgsEx(const char *file, char **filebuf, int lim);
extern int BAG_Filesystem_GetArgs(char **argv, int num);
extern void BAG_Filesystem_FreeArgs(char **argv, int num);
extern s8 BAG_Filesystem_FileExists(const char *path);
extern s8 BAG_Filesystem_GetMagicNumbers(const char *path, u8 *dataBuf, s8 numBytes);
extern s8 BAG_Filesystem_FindFileExt(const char *path, char *extList[], int extCount, char *newPath, int newPathLen);
extern u32 BAG_Filesystem_GetFileSize(const char *file);
extern u8 *BAG_Filesystem_LoadFile(const char *file);
extern u8 *BAG_Filesystem_LoadFileWithSize(const char *file, u32 *size);

#include "args.h"

#ifdef __cplusplus
}
#endif


#endif
